# TODO:
# - BUG: you can't set in /etc/mdadm.conf:
#  DEVICE partitions containers
#  (which is default BTW if none set). Generation of initrd will fail
#
Summary:	Creates an initial ramdisk image for preloading modules
Summary(pl.UTF-8):	Narzędzie do tworzenia inicjalnego ramdysku używanego przy starcie systemu
Name:		geninitrd
Version:	12757
Release:	7
License:	GPL
Group:		Applications/System
Source0:	%{name}-%{version}.tar.gz
# Source0-md5:	3fb153489c3c245e5c1ee4bbc333acb4
Patch0:		%{name}-git.patch
Patch1:		%{name}-static-dev.patch
Patch2:		%{name}-posix-sh.patch
URL:		http://git.pld-linux.org/?p=projects/geninitrd.git
BuildRequires:	xmlto >= 0:0.0.18-1
Requires:	/usr/bin/ldd
Requires:	awk
Requires:	busybox-implementation >= 1.22.1-2
Requires:	coreutils
Requires:	cpio
Requires:	fileutils
Requires:	glibc-misc
Requires:	gzip
Requires:	mktemp >= 1.5-8
Requires:	mount
Requires:	pci-database >= 0.4
Requires:	rc-scripts >= 0.2.7
Requires:	tar
Requires:	virtual(module-tools)
Requires:	xz
Suggests:	genromfs
Suggests:	pciutils
Obsoletes:	mkinitrd
# suggest for blkid
%if "%{pld_release}" == "ac"
# otherwise LVM subsystem is not enabled in geninitrd
Suggests:	lvm2-initrd
# without this softraid installations of PLD fail
Suggests:	mdadm-initrd >= 1.12.0-1
Conflicts:	grubby < 5.0.4-3.1
%else
Conflicts:	grubby < 6.0.24-3
%endif
Conflicts:	kmod < 7-2
Conflicts:	module-init-tools < 3.2.2-6
Conflicts:	pciutils < 2.2.9
Conflicts:	udev-initrd < 1:168
Conflicts:	xz < 4.999.9
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Geninitrd creates filesystem images for use as initial ramdisk
(initrd) images. These ramdisk images are often used to preload the
block device modules (SCSI or RAID) needed to access the root
filesystem.

In other words, generic kernels can be built without drivers for any
SCSI adapters which load the SCSI driver as a module. Since the kernel
needs to read those modules, but in this case it isn't able to address
the SCSI adapter, an initial ramdisk is used. The initial ramdisk is
loaded by the operating system loader (normally LILO) and is available
to the kernel as soon as the ramdisk is loaded. The ramdisk image
loads the proper SCSI adapter and allows the kernel to mount the root
filesystem. The geninitrd program creates such a ramdisk using
information found in the /etc/modules.conf file.

%description -l pl.UTF-8
Geninitrd służy do tworzenia obrazu systemu plikowego używanego jako
inicjalny ramdysk (initrd), z którego przy starcie systemu są ładowane
moduły kernela z obsługą urządzeń których obsługa nie jest
wkompilowana w kernel. Zazwyczaj modułami ładowanymi z inicjalnego
systemu plikowego są sterowniki SCSI, IDE czy też RAID po to żeby w
dalszej części inicjacji systemu był możliwy dostęp do głównego
systemu plikowego (root fs).

Dzięki initrd jest możliwe używanie dystrybucyjnego kernela w którym
wkompilowana jest minimalna ilość obsługi różnych urządzeń, a reszta
kodu obsługi sterowników SCSI, IDE czy RAID jest doczytywana w trakcie
startu z initrd. Skrypt geninitrd generuje obraz ramdysku na podstawie
bieżących informacji zawartych w /etc/modules.conf.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc ChangeLog
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/geninitrd
%attr(755,root,root) /sbin/geninitrd
%{_mandir}/man8/geninitrd.8*

%dir /lib/geninitrd
/lib/geninitrd/functions
/lib/geninitrd/mod-*.sh
%attr(755,root,root) /lib/geninitrd/extract-ikconfig

%dir /lib/geninitrd/udev-rules
/lib/geninitrd/udev-rules/*.rules
%changelog
* Sat Jul 02 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/geninitrd.git;a=log;h=master

* Tue Jun 21 2016 Jakub Bogusz <qboosh@pld-linux.org> 89be020
- added static-dev patch (don't force devtmpfs if udev is disabled in target system)
- added posix-sh patch (don't use non-POSIX ${ / / } extension)
- release 7

* Tue Jun 07 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> af5fc81
- rel 6

* Tue Jun 07 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 95e49aa
- rel 5; mount /run with 0755 (security issue)

* Fri May 13 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> f904563
- rel 4; fix fallback

* Fri May 13 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> dfdfecb
- rel 3; R: busybox-implementation

* Sun Jan 31 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> eb76cce
- use git patch

* Sun Jan 31 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 4c88056
- rel 2; compressors list changed to make best (size) ones as first; always add partitions and containers to initrd mdadm config.

* Tue Nov 17 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> bcdb1d4
- comment out patch

* Tue Nov 17 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 11d3d39
- up to 12757

* Sun Jun 28 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 361d008
- rel 3; group for udev and yet another rootfs fallback

* Thu Mar 26 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 464ad04
- rel 2; libdir brokeness fixed

* Mon Mar 23 2015 Elan Ruusamäe <glen@delfi.ee> 8f10598
- up to 12749 (x32 fixes)

* Wed Feb 25 2015 Elan Ruusamäe <glen@delfi.ee> 1e38233
- modules are compressed with .xz on master branch

* Wed Nov 26 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> e4008f8
- rel 2; allow discard for LUKS devices

* Sat Nov 08 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 240c97d
- up to 12744 (load font, antirace mdev, support for 3.18 compressed modules, load btrfs related modules when needed)

* Tue Oct 14 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> b66ea22
- rel 4; support for compressed modules used in 3.18.x kernels

* Mon Jun 09 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> c93f3d5
- rel 3; load font at initrd

* Wed May 14 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> ebc0b85
- rel 2; fix dmcrypt 'Udev cookie 0xd4dc311 (semid 229380) waiting for zero' problem

* Wed May 14 2014 Elan Ruusamäe <glen@delfi.ee> d322667
- up to 12736, fixes lvm on romfs boot issue

* Tue Apr 22 2014 Elan Ruusamäe <glen@delfi.ee> da72fe2
- require busybox with mdev support

